;###########################################################
; *WindowFromPoint*
;  API tester by kero <geocities.com/xmemor>
; (2009-06-14)
;###########################################################
; ml /c /coff /I\masm32\include HTSpy.asm
; link /subsystem:windows /LIBPATH:\masm32\lib HTSpy.obj

.386
.model flat,stdcall  ; 'ml /Gz'
option casemap:none  ; 'ml /Cp'

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32

.const
  id     equ 100
  
.data
 _static  db "Static  Child",0
 _button  db "Button",0
 _txt     db "R-click :   WS_EX_COMPOSITED   on/off  ",0
 _real    db "RealChild  ",0 
 _lwa     db "LWA_ALPHA + LWA_COLORKEY",0
 _thread  db "Same Thread",0
 _process db "Same Process, other Thread",0
 _csrss   db "CSRSS    (Windows XP)",0  ;  (Pro SP2)
 _user    db "user32",0
 _slwa    db "SetLayeredWindowAttributes",0 
 _wfp     db "   Parent <F8>",              13,10,13,10
          db " WindowFromPoint",            13,10,13,10 
          db "RealChildWindowFromPoint",    13,10
          db "ChildWindowFromPointEx",      13,10,13,10
          db "AdvRealChildWindowFromPoint", 13,10
          db "AdvChildWindowFromPointEx",   13,10,13,10
          db " PtInWindowFromPoint",        13,10
          db " PtInWindowFromPoint2",       13,10,13,10
          db "PtInRealChildWindowFromPoint",13,10
          db "PtInChildWindowFromPointEx",0
 _ft2     db "%s",13,10,13,10
          db "%s",13,10,13,10 
          db "%s",13,10
          db "%s",13,10,13,10
          db "%s",13,10
          db "%s",13,10,13,10
          db "%s",13,10
          db "%s",13,10,13,10          
          db "%s",13,10
          db "%s",0
 _ft1     db "%8.8lX  %4.4lX   %2.d   %s   ""%s""",0
 _ft0     db "screen: %d, %d",13,10
          db "client:   %d, %d",0
  lf      LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Courier New">
  rct     RECT <0,0,100,100>
  
.data?
  hinst   HINSTANCE ?
  hw      HWND ?  ; fix wnd
  hwin    HWND ?  ; child dlg
  hfont   HFONT ?
  
.code

PtInWindow proc uses ebx edi hWnd:HWND,ptx:DWORD,pty:DWORD
  local rt:RECT
  xor ebx,ebx
  invoke CreateRectRgn,ebx,ebx,ebx,ebx
  mov edi,eax  
  invoke GetWindowRect,hWnd,addr rt
  invoke PtInRect,addr rt,ptx,pty
  test eax,eax
  jz @f
  invoke GetWindowRgn,hWnd,edi
  .if eax==SIMPLEREGION || eax==COMPLEXREGION
    mov eax,ptx
    sub eax,rt.left
    mov ecx,pty
    sub ecx,rt.top
    invoke PtInRegion,edi,eax,ecx
    mov ebx,eax
  .else
    inc ebx
  .endif
@@:
  invoke DeleteObject,edi
  mov eax,ebx
  ret
PtInWindow endp


PtInWnd proc uses ebx edi hWnd:HWND,lParam:LPARAM
  mov edi,lParam
  assume edi:PTR RECT
  xor ebx,ebx
  inc ebx
  invoke IsWindowVisible,hWnd
  test eax,eax
  jz @f
  invoke PtInWindow,hWnd,[edi].left,[edi].top
  .if eax!=0
    xor ebx,ebx
    mov eax,hWnd
    mov [edi].right,eax
    mov [edi].bottom,eax
  .endif
@@:
  assume edi:nothing
  mov eax,ebx
  ret
PtInWnd endp


PtInWindowFromPoint proc ptx:DWORD,pty:DWORD,lParam:LPARAM  ; (screen coordinates)
  local rt:RECT

  mov ecx,ptx
  mov rt.left,ecx
  mov ecx,pty
  mov rt.top,ecx
  .if lParam==0                                ; PtInWindowFromPoint
    xor ecx,ecx
    mov rt.right,ecx
    mov rt.bottom,ecx
    invoke EnumWindows,offset PtInWnd,addr rt
    .if rt.right!=0                            ; PtInWindowFromPoint2
      mov edx,rt.right
      jmp @f
    .else
      jmp @1
    .endif
  .else
@1:
    invoke GetDesktopWindow
    mov edx,eax
    mov rt.right,edx  
@@:
    xor ecx,ecx
    mov rt.bottom,ecx
    invoke EnumChildWindows,edx,offset PtInWnd,addr rt
    mov edx,rt.right
    mov ecx,rt.bottom
    test ecx,ecx
    jnz @b
  .endif
  invoke PtInWnd,edx,addr rt
  mov eax,rt.bottom
  ret
PtInWindowFromPoint endp


AdvChildWindowFromPoint proc uses ebx edi hWnd:HWND,ptx:DWORD,pty:DWORD,param1:DWORD,param2:DWORD  ; (screen coordinates)
 local pt:POINT
 local rt:RECT
 
  mov eax,ptx
  mov pt.x,eax
  mov rt.left,eax
  mov eax,pty
  mov pt.y,eax
  mov rt.top,eax
  mov ebx,hWnd
  xor ecx,ecx
  mov rt.right,ecx
  mov rt.bottom,ecx
  .while TRUE
    invoke MapWindowPoints,ecx,ebx,addr pt,1
    .if param1!=0
      invoke RealChildWindowFromPoint,ebx,pt.x,pt.y
    .else    
      invoke ChildWindowFromPointEx,ebx,pt.x,pt.y,CWP_SKIPINVISIBLE  ; CWP_ALL
    .endif
    .break .if !(eax!=0 && eax!=ebx)
      mov ecx,ebx
      mov ebx,eax
  .endw
  .if param2!=0
    mov rt.right,ebx
@@:  
    mov ecx,rt.right
    xor eax,eax
    mov rt.bottom,eax
    invoke EnumChildWindows,ecx,addr PtInWnd,addr rt  
    mov eax,rt.bottom
    test eax,eax
    jnz @b
    mov ebx,rt.right
  .endif
  mov eax,ebx
  ret
AdvChildWindowFromPoint endp


ThreadProc proc lParam:LPARAM
  mov eax,lParam
  .if eax==MB_TOPMOST
    mov ecx,offset _csrss
  .else
    mov ecx,offset _process
  .endif
  invoke MessageBox,0,offset _static,ecx,eax  ; // on XP-pro-sp2: MB_TOPMOST=0x00040000=MB_SERVICE_NOTIFICATION_NT3X => CSRSS
  ret
ThreadProc endp


FromPt proc uses ebx lpstr:LPSTR,lP:DWORD,hWnd:HWND
  local buf1[38]:BYTE
  local buf2[38]:BYTE  
  
  mov byte ptr[buf1],0
  mov byte ptr[buf2],0
  .if hw!=0
    mov eax,hw
  .else
    mov eax,hWnd
  .endif
  invoke DefWindowProc,eax,WM_NCHITTEST,0,lP
  mov ebx,eax
  invoke GetClassName,hWnd,addr buf1,37
  invoke GetWindowText,hWnd,addr buf2,37
  .if eax!=0
    lea edx,buf2
    .while eax!=0
      mov cl,byte ptr[edx+eax]
      .if cl==10 || cl==13
        mov byte ptr[edx+eax],0
      .endif
      dec eax
    .endw
  .endif
  invoke GetWindowLong,hWnd,GWL_ID
;  invoke GetMenu,hWnd
;;  invoke GetDlgCtrlID,hWnd
  mov edx,eax
  and edx,0ffffh
  invoke wsprintf,lpstr,offset _ft1,hWnd,edx,ebx,addr buf1,addr buf2
  ret
FromPt endp


OnTimer proc uses ebx edi esi hWnd:HWND
  local rt:RECT
  local pt:POINT
  local buf1[100]:BYTE
  local buf2[100]:BYTE
  local buf3[100]:BYTE
  local buf4[100]:BYTE
  local buf5[100]:BYTE
  local buf6[100]:BYTE
  local buf7[100]:BYTE
  local buf8[100]:BYTE
  local buf9[100]:BYTE
  local buf10[100]:BYTE
  local bufA[1024]:BYTE
  local bufB[1024]:BYTE
  
  invoke GetCursorPos,addr pt  ; (screen coordinates)
  invoke WindowFromPoint,pt.x,pt.y
  mov ebx,eax
  invoke GetKeyState,VK_CONTROL
  and eax,8000h
  .if eax!=0
    invoke GetAncestor,ebx,GA_ROOT
    mov ebx,eax
  .endif
  invoke SendDlgItemMessage,hWnd,id,BM_GETCHECK,0,0
  .if eax==0    
    invoke GetKeyState,VK_F8  ; fix hw
    and eax,8000h
    .if eax!=0
      invoke SendDlgItemMessage,hWnd,id,BM_SETCHECK,1,0    
      mov hw,ebx
    .else
      mov hw,0
    .endif
  .else
    mov ebx,hw
  .endif
  mov edi,pt.x
  and edi,0ffffh
  mov eax,pt.y
  shl eax,16
  or edi,eax  ; lP
  invoke FromPt,addr buf1,edi,ebx
  invoke WindowFromPoint,pt.x,pt.y
  invoke FromPt,addr buf2,edi,eax
  invoke PtInWindowFromPoint,pt.x,pt.y,0
  invoke FromPt,addr buf7,edi,eax
  invoke PtInWindowFromPoint,pt.x,pt.y,1
  invoke FromPt,addr buf10,edi,eax
  .if hw==0
    invoke GetDesktopWindow
    mov ebx,eax
  .else
    mov ebx,hw
  .endif
  invoke AdvChildWindowFromPoint,ebx,pt.x,pt.y,1,0 ; AdvRealChild...
  invoke FromPt,addr buf5,edi,eax
  invoke AdvChildWindowFromPoint,ebx,pt.x,pt.y,0,0 ; AdvChild...
  invoke FromPt,addr buf6,edi,eax
  invoke AdvChildWindowFromPoint,ebx,pt.x,pt.y,1,1 ; PtInRealChild...
  invoke FromPt,addr buf8,edi,eax
  invoke AdvChildWindowFromPoint,ebx,pt.x,pt.y,0,1 ; PtInChild...
  invoke FromPt,addr buf9,edi,eax
  push pt.x
  push pt.y
  invoke MapWindowPoints,0,ebx,addr pt,1  ; (client coordinates)
  pop ecx
  pop eax
  invoke wsprintf,addr buf3,offset _ft0,eax,ecx,pt.x,pt.y
  invoke GetDlgItemText,hWnd,id+6,addr buf4,99
  invoke lstrcmp,addr buf3,addr buf4
  .if eax!=0
    invoke SetDlgItemText,hWnd,id+6,addr buf3
  .endif
  invoke ChildWindowFromPointEx,ebx,pt.x,pt.y,CWP_SKIPINVISIBLE
  invoke FromPt,addr buf3,edi,eax
  invoke RealChildWindowFromPoint,ebx,pt.x,pt.y
  invoke FromPt,addr buf4,edi,eax
  invoke wsprintf,addr bufA,offset _ft2,addr buf1,addr buf2,addr buf4,addr buf3,addr buf5,addr buf6,addr buf7,addr buf10,addr buf8,addr buf9
  invoke GetDlgItemText,hWnd,id+1,addr bufB,1023
  invoke lstrcmp,addr bufA,addr bufB
  .if eax!=0
    invoke SetDlgItemText,hWnd,id+1,addr bufA
  .endif
  mov esi,id+2
  .while esi!=id+3
    invoke GetWindowRect,hWnd,addr rt
    mov ebx,rt.left
    mov edi,rt.top
    invoke GetDlgItem,hWnd,esi
    mov ecx,eax
    invoke GetWindowRect,ecx,addr rt
    sub rt.left,ebx
    sub rt.right,ebx
    sub rt.top,edi
    sub rt.bottom,edi
    invoke GetWindowDC,hWnd
    mov ebx,eax
    invoke GetStockObject,BLACK_BRUSH
    invoke FrameRect,ebx,addr rt,eax
    invoke ReleaseDC,hWnd,ebx
    inc esi
  .endw

  ret
OnTimer endp


NewBtn proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local ps:PAINTSTRUCT
  
  .if uMsg==WM_PAINT
    invoke BeginPaint,hWnd,addr ps
    mov ebx,eax
    invoke GetStockObject,BLACK_BRUSH
    invoke FillRect,ebx,addr rct,eax
    invoke EndPaint,hWnd,addr ps
  .else
    invoke GetWindowLong,hWnd,GWL_USERDATA
    invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  .endif
  ret
NewBtn endp


SubProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if uMsg==WM_SIZE
    invoke GetAncestor,hWnd,GA_PARENT
    invoke InvalidateRect,eax,0,1
  .endif
  invoke GetWindowLong,hWnd,GWL_USERDATA
  invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  ret
SubProc endp


DlgProc1 proc uses ebx edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local ps:PAINTSTRUCT
  local rt:RECT

  .if uMsg==WM_CTLCOLORDLG
    invoke GetStockObject,WHITE_BRUSH

  .elseif uMsg==WM_PAINT
    invoke BeginPaint,hWnd,addr ps
    mov ebx,eax
    invoke GetStockObject,DEFAULT_GUI_FONT
    invoke SelectObject,ebx,eax
    push eax
    invoke SetBkMode,ebx,TRANSPARENT
    invoke SetTextColor,ebx,Red
    invoke lstrlen,offset _txt
    invoke TextOut,ebx,0,6,offset _txt,eax
    invoke GetClientRect,hWnd,addr rt
    mov edi,rt.right
    invoke GetDlgItem,hWnd,id
    mov edx,eax
    invoke GetWindowRect,edx,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2
    mov eax,rt.left
    mov ecx,rt.right
    sub eax,edi
    sub ecx,edi
    neg eax
    neg ecx
    mov rt.left,ecx
    mov rt.right,eax
    invoke GetStockObject,BLACK_BRUSH
    invoke FrameRect,ebx,addr rt,eax
    add rt.top,4
    invoke lstrlen,offset _real
    invoke TextOut,ebx,rt.left,rt.top,offset _real,eax
    pop eax
    invoke SelectObject,ebx,eax
    invoke EndPaint,hWnd,addr ps    
    mov eax,TRUE

  .elseif uMsg==WM_COMMAND && wParam==id
    invoke MessageBeep,0
    mov eax,TRUE

  .elseif uMsg==WM_RBUTTONDOWN             ; try R-click (WS_EX_LAYOUTRTL +/- WS_EX_COMPOSITED) :)
    invoke GetWindowLong,hWnd,GWL_EXSTYLE
    mov ecx,eax
    mov edx,WS_EX_COMPOSITED
    or eax,edx
    .if eax==ecx
      not edx
      and eax,edx
    .endif
    invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
    jmp @f
    
  .elseif uMsg==WM_INITDIALOG
    invoke GetDlgItem,hWnd,id
    mov ebx,eax
    invoke SetWindowLong,ebx,GWL_WNDPROC,addr SubProc
    invoke SetWindowLong,ebx,GWL_USERDATA,eax
@@:
    invoke SetWindowPos,hWnd,HWND_TOP,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE or SWP_FRAMECHANGED
@@:
    invoke InvalidateRect,hWnd,0,1
    mov eax,TRUE
    
  .elseif uMsg==WM_SIZE
    jmp @b
    
  .else
    mov eax,FALSE
  .endif
  ret
DlgProc1 endp


DlgProc proc uses ebx edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local rt:RECT
  
  .if uMsg==WM_CLOSE
    invoke KillTimer,hWnd,id  
    invoke DeleteObject,hfont  
    invoke EndDialog,hWnd,0
    mov eax,TRUE
    
  .elseif uMsg==WM_INITDIALOG
    invoke CreateFontIndirect,offset lf
    mov hfont,eax
    invoke SetDlgItemText,hWnd,id+7,offset _wfp
    invoke SendDlgItemMessage,hWnd,id+7,WM_SETFONT,hfont,1
    invoke SendDlgItemMessage,hWnd,id+1,WM_SETFONT,hfont,1
    invoke CreateDialogParam,hinst,id+1,hWnd,offset DlgProc1,0
    mov hwin,eax
    invoke SetTimer,hWnd,id,40,0
    mov eax,FALSE

  .elseif uMsg==WM_COMMAND ; && lParam==0
    mov eax,wParam
    .if eax==id-1
      invoke MessageBox,0,offset _static,offset _thread,MB_TOPMOST
    .elseif eax==id-2
      mov eax,MB_OK
      jmp @f
    .elseif eax==id-3
      mov eax,MB_TOPMOST
@@:
      invoke CreateThread,0,0,offset ThreadProc,eax,0,0
      invoke CloseHandle,eax
    .elseif eax==id-4 ; LWA
      invoke CreateWindowEx,0,offset _button,offset _lwa,WS_POPUP or WS_CAPTION or WS_SYSMENU or WS_VISIBLE or BS_OWNERDRAW,0,0,300,200,hWnd,0,hinst,0
      mov ebx,eax
      invoke SetWindowLong,ebx,GWL_WNDPROC,addr NewBtn
      invoke SetWindowLong,ebx,GWL_USERDATA,eax
      invoke GetClassLong,ebx,GCL_STYLE
      mov edi,eax
      and eax,not CS_PARENTDC
      invoke SetClassLong,ebx,GCL_STYLE,eax
      invoke SetWindowLong,ebx,GWL_EXSTYLE,WS_EX_LAYERED
      invoke SetWindowPos,ebx,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE or SWP_FRAMECHANGED
;      invoke SetLayeredWindowAttributes,ebx,0,180,LWA_ALPHA or LWA_COLORKEY  ; (for WinOS>=2k)
      invoke GetModuleHandle,offset _user  ; (for Win98)
      invoke GetProcAddress,eax,offset _slwa
      test eax,eax
      jz @f
      push LWA_ALPHA or LWA_COLORKEY
      push 180
      push 0
      push ebx
      call eax
@@:
      invoke SetClassLong,ebx,GCL_STYLE,edi
    .endif    
    mov eax,TRUE
    
  .elseif uMsg==WM_CTLCOLORSTATIC || uMsg==WM_CTLCOLORDLG
    invoke GetWindowLong,lParam,GWL_ID
    .if eax==id
      mov eax,FALSE
    .else
      invoke GetStockObject,WHITE_BRUSH
    .endif
    
  .elseif uMsg==WM_SIZE
    invoke GetWindowRect,hWnd,addr rt
    mov edi,rt.right
    sub edi,rt.left
    sub edi,243
    invoke GetDlgItem,hWnd,id+1
    mov ebx,eax
    invoke GetWindowRect,ebx,addr rt
    mov eax,rt.bottom
    sub eax,rt.top
    invoke SetWindowPos,ebx,0,0,0,edi,eax,SWP_NOZORDER or SWP_NOMOVE or SWP_NOACTIVATE or SWP_FRAMECHANGED
    mov eax,TRUE
    
  .elseif uMsg==WM_TIMER
    invoke OnTimer,hWnd
    mov eax,TRUE
    
	.else
    mov eax,FALSE
  .endif
  ret
DlgProc endp

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke DialogBoxParam,eax,id,0,offset DlgProc,0
  invoke ExitProcess,eax
  invoke InitCommonControls
end start
